/*
 *  This file is provided for use with the unix-socket-faq.  It is public
 *  domain, and may be copied freely.  There is no copyright on it.  The
 *  original work was by Vic Metcalfe (vic@brutus.tlug.org), and any
 *  modifications made to that work were made with the understanding that
 *  the finished work would be in the public domain.
 *
 *  If you have found a bug, please pass it on to me at the above address
 *  acknowledging that there will be no copyright on your work.
 *
 *  The most recent version of this file, and the unix-socket-faq can be
 *  found at http://www.interlog.com/~vic/sock-faq/.
 */
/* Changes for IPv6 by Marc Mosthav, SIEMENS plc */
/* please read README.ipv6 for copyright information on these changes */
/* CAUTION: this file has been truncated!!! */

#include "sockhelp.h"

/* Converts ascii text to in_addr struct.  NULL is returned if the address
   can not be found. */
struct in6_addr *atoaddr6(address)
char *address;
{
  struct hostent *host;
  static struct in6_addr saddr;

  /* First try it as aaa.bbb.ccc.ddd. */
  if(inet_pton(AF_INET6,address,&(saddr))>0) {
	  return &saddr;
  }
  host = gethostbyname2(address,AF_INET6);
  if (host != NULL) {
	  return (struct in6_addr *) *host->h_addr_list;
  }
  return NULL;
}

/* Converts ascii text to in_addr struct.  NULL is returned if the address
   can not be found. */
struct in_addr *atoaddr(address)
char *address;
{
  struct hostent *host;
  static struct in_addr saddr;

  /* First try it as aaa.bbb.ccc.ddd. */
  saddr.s_addr = inet_addr(address);
  if (saddr.s_addr != -1) {
    return &saddr;
  }
  host = gethostbyname(address);
  if (host != NULL) {
    return (struct in_addr *) *host->h_addr_list;
  }
  return NULL;
}
